import { HPCCElement } from "./element";
import { HTMLTemplate } from "./html";
export declare type PropertyType = "string" | "boolean" | "number";
export interface PropertyBase {
    type: PropertyType;
    name: string;
    isAttribute: boolean;
}
export interface StringProperty extends PropertyBase {
    type: "string";
}
export interface NumberProperty extends PropertyBase {
    type: "number";
}
export interface BooleanProperty extends PropertyBase {
    type: "boolean";
}
export declare type Property = StringProperty | NumberProperty | BooleanProperty;
export interface ClassMeta {
    tag: string;
    template?: HTMLTemplate;
    styles: string;
    properties: Property[];
    observedAttributes: string[];
    observedProperties: string[];
    observed: {
        [id: string]: Property;
    };
    events: string[];
}
export declare function allMeta(): {
    [id: string]: ClassMeta;
};
export declare function classMeta(target: CustomElementConstructor | string): Readonly<ClassMeta>;
export declare function instanceMeta(target: HPCCElement): Readonly<ClassMeta>;
export declare type CustomElementOption = {
    template?: HTMLTemplate;
    styles?: string;
    events?: string[];
};
export declare function customElement(name: string, opts?: CustomElementOption): (target: CustomElementConstructor) => void;
export declare type OptionsEx = Omit<PropertyBase, "name" | "isAttribute">;
export declare function attribute(config?: OptionsEx): (target: HPCCElement, property: string) => void;
export declare function attribute(target: HPCCElement, prop: string): void;
export declare function property(config?: OptionsEx): (target: HPCCElement, property: string) => void;
export declare function property(target: HPCCElement, prop: string): void;
//# sourceMappingURL=decorator.d.ts.map