import type { CSSProperties, DOMAttributes } from "react";
declare type CustomEvents<K extends string> = {
    [key in K]: (event: CustomEvent) => void;
};
declare type CustomElement<T extends HTMLElement> = Omit<T & DOMAttributes<T>, "style"> & {
    style?: CSSProperties | undefined;
    children: any;
};
export declare type WebComponent<T extends HTMLElement, K extends string = ""> = Partial<CustomElement<T> & CustomEvents<`on${K}`>>;
export {};
//# sourceMappingURL=react.d.ts.map